Bug 110500 - X-Server crashes - GL error: GL_OUT_OF_MEMORY in glTexSubImage
Summary: X-Server crashes - GL error: GL_OUT_OF_MEMORY in glTexSubImage
Status: RESOLVED NOTOURBUG
Alias: None
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/nouveau (show other bugs)
Version: git
Hardware: x86-64 (AMD64) Linux (All)
: medium major
Assignee: Nouveau Project
QA Contact: Nouveau Project
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2019-04-23 15:34 UTC by wixbisce@guerrillamail.com
Modified: 2019-08-07 20:20 UTC (History)
0 users

See Also:
i915 platform:
i915 features:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description wixbisce@guerrillamail.com 2019-04-23 15:34:49 UTC
I try to convert someone from Windows to Linux. I installed Kubuntu 18.04.2 . Suddenly while using it the screen went black and afterwards i had the login screen.

cat /var/log/Xorg.0.log.old

[  2309.613] (EE) glamor0: GL error: GL_OUT_OF_MEMORY in glTexSubImage
[  2309.613] (WW) glamor: Failed to allocate 455x25 FBO due to GL_OUT_OF_MEMORY.
[  2309.613] (WW) glamor: Expect reduced performance.
[  2331.150] (EE) glamor0: GL error: GL_OUT_OF_MEMORY in glTexSubImage
[  2331.150] (EE) 
[  2331.150] (EE) Backtrace:
[  2331.151] (EE) 0: /usr/lib/xorg/Xorg (OsLookupColor+0x139) [0x561f602bb459]
[  2331.151] (EE) 1: /lib/x86_64-linux-gnu/libpthread.so.0 (funlockfile+0x50) [0x7fa3b600a8df]
[  2331.151] (EE) 2: /usr/lib/xorg/modules/libglamoregl.so (glamor_get_pixmap_texture+0x7d) [0x7fa3b2a6155d]
[  2331.152] (EE) 3: /usr/lib/xorg/modules/libglamoregl.so (glamor_create_gc+0x78f4) [0x7fa3b2a73644]
[  2331.152] (EE) 4: /usr/lib/xorg/modules/libglamoregl.so (glamor_create_gc+0x7caf) [0x7fa3b2a73d6f]
[  2331.152] (EE) 5: /usr/lib/xorg/modules/libglamoregl.so (glamor_create_gc+0x8668) [0x7fa3b2a74888]
[  2331.152] (EE) 6: /usr/lib/xorg/modules/libglamoregl.so (glamor_create_gc+0xa26f) [0x7fa3b2a7807f]
[  2331.152] (EE) 7: /usr/lib/xorg/Xorg (DamageRegionAppend+0x6c6) [0x561f6023e996]
[  2331.153] (EE) 8: /usr/lib/xorg/modules/libglamoregl.so (glamor_create_gc+0x1110f) [0x7fa3b2a8645f]
[  2331.153] (EE) 9: /usr/lib/xorg/Xorg (AddTraps+0x423d) [0x561f602375ed]
[  2331.153] (EE) 10: /usr/lib/xorg/Xorg (SendErrorToClient+0x368) [0x561f6015e498]
[  2331.153] (EE) 11: /usr/lib/xorg/Xorg (InitFonts+0x3c8) [0x561f60162478]
[  2331.154] (EE) 12: /lib/x86_64-linux-gnu/libc.so.6 (__libc_start_main+0xe7) [0x7fa3b5c21b97]
[  2331.154] (EE) 13: /usr/lib/xorg/Xorg (_start+0x2a) [0x561f6014c13a]
[  2331.154] (EE) 
[  2331.154] (EE) Segmentation fault at address 0x0
[  2331.154] (EE) 
Fatal server error:
[  2331.154] (EE) Caught signal 11 (Segmentation fault). Server aborting


OS: Kubuntu 18.04.2 LTS release.
Hardware: 8GB RAM, Nvidia 9500 passive cooled GPU
Comment 1 Ilia Mirkin 2019-04-23 16:02:43 UTC
Please use xf86-video-nouveau, not modesetting.
Comment 2 wixbisce@guerrillamail.com 2019-04-23 18:23:13 UTC
The package https://packages.ubuntu.com/bionic-updates/xserver-xorg-video-nouveau-hwe-18.04 is already installed by default.

I have a /usr/lib/xorg/modules/drivers/nouveau_drv.so file.

lsmod |grep nouveau
nouveau              1851392  21
video                  45056  1 nouveau
i2c_algo_bit           16384  1 nouveau
mxm_wmi                16384  1 nouveau
ttm                   110592  1 nouveau
drm_kms_helper        172032  1 nouveau
drm                   458752  11 drm_kms_helper,ttm,nouveau
wmi                    24576  2 mxm_wmi,nouveau


I dont know how to use something special. I just installed the OS and have the issues i linked. I am using the LTS release for stability.

It crashed already few times.
It crashed few minutes again. Here the last log:

[  4869.797] (EE) glamor0: GL error: GL_OUT_OF_MEMORY in glTexSubImage
[  4869.797] (WW) glamor: Failed to allocate 455x1 FBO due to GL_OUT_OF_MEMORY.
[  4869.797] (WW) glamor: Expect reduced performance.
[  4869.798] (EE) 
[  4869.798] (EE) Backtrace:
[  4869.798] (EE) 0: /usr/lib/xorg/Xorg (OsLookupColor+0x139) [0x5630e630d459]
[  4869.798] (EE) 1: /lib/x86_64-linux-gnu/libpthread.so.0 (funlockfile+0x50) [0x7fea4ef6a8df]
[  4869.798] (EE) 2: /usr/lib/xorg/modules/libglamoregl.so (glamor_get_pixmap_texture+0x7d) [0x7fea4b9c155d]
[  4869.799] (EE) 3: /usr/lib/xorg/modules/libglamoregl.so (glamor_create_gc+0x78f4) [0x7fea4b9d3644]
[  4869.799] (EE) 4: /usr/lib/xorg/modules/libglamoregl.so (glamor_create_gc+0x7caf) [0x7fea4b9d3d6f]
[  4869.799] (EE) 5: /usr/lib/xorg/modules/libglamoregl.so (glamor_create_gc+0x8668) [0x7fea4b9d4888]
[  4869.799] (EE) 6: /usr/lib/xorg/modules/libglamoregl.so (glamor_create_gc+0xa26f) [0x7fea4b9d807f]
[  4869.799] (EE) 7: /usr/lib/xorg/Xorg (DamageRegionAppend+0x6c6) [0x5630e6290996]
[  4869.800] (EE) 8: /usr/lib/xorg/modules/libglamoregl.so (glamor_create_gc+0x1110f) [0x7fea4b9e645f]
[  4869.800] (EE) 9: /usr/lib/xorg/Xorg (AddTraps+0x423d) [0x5630e62895ed]
[  4869.800] (EE) 10: /usr/lib/xorg/Xorg (SendErrorToClient+0x368) [0x5630e61b0498]
[  4869.800] (EE) 11: /usr/lib/xorg/Xorg (InitFonts+0x3c8) [0x5630e61b4478]
[  4869.800] (EE) 12: /lib/x86_64-linux-gnu/libc.so.6 (__libc_start_main+0xe7) [0x7fea4eb81b97]
[  4869.800] (EE) 13: /usr/lib/xorg/Xorg (_start+0x2a) [0x5630e619e13a]
[  4869.800] (EE) 
[  4869.800] (EE) Segmentation fault at address 0x0
[  4869.800] (EE) 
Fatal server error:
[  4869.800] (EE) Caught signal 11 (Segmentation fault). Server aborting
Comment 3 Ilia Mirkin 2019-04-23 18:28:43 UTC
You might have it, but it's not being used. You probably see

modeset(0)

in your xorg logs (i.e. the "modesetting" driver) instead of

NOUVEAU(0)

which would imply it's using xf86-video-nouveau.
Comment 4 Karol Herbst 2019-04-23 18:44:54 UTC
meh.. I want to move that bug to glamor, but that doesn't work. In either case, glamor shouldn't crash just because it couldn't allocate some memory and that has to get fixed.

We can workaround that issue for the user, but others might run into the same.
Comment 5 wixbisce@guerrillamail.com 2019-04-23 18:56:06 UTC
Karol Herbst gave me this here to put into /etc/X11/xorg.conf.d/20-nouveau.conf:

Section "Device"
        Identifier "NvidiaCard"
        Driver "nouveau"
        BusID "PCI:01:00:0" # PCI bus address of the Nvidia GPU here
EndSection

I had to create xorg.conf.d first. Afterwards i put the config file there inside.

Now i also see in the xorg.log NOUVEAU(0). Lets hope the machine works fine now.

I think this should be fixed so that normal user dont have to struggle around with this. I think i am a more advanced user. The person i help here that would like to switch to Linux told me now about 10 times that he would not have been able to do that what i did (understand that its nouveau, report a bug, know about IRC, join IRC, dmesg things, lsmod things, ...).

This is a machine with 8 CPU cores, support up to 32GB of RAM, ... It have been updated few times. Its just for office usage. The GPU have 512MB of VRAM. I have played good looking games on 128MB of VRAM.
The system should not crash in office mode (browsing the emails in a email software, not browser).
Comment 6 Ilia Mirkin 2019-04-23 19:16:02 UTC
(In reply to wixbisce@guerrillamail.com from comment #5)
> I think this should be fixed so that normal user dont have to struggle
> around with this.

Agreed. Your distro has made some sort of modification which causes modeset to be preferred to nouveau. Feel free to inform them that this was a poor idea.

IMO, nouveau's GL implementation is a bad match for GLAMOR.
Comment 7 wixbisce@guerrillamail.com 2019-04-24 10:38:27 UTC
I talked with a developer. I get told, that when a driver provide a functionality, that functionality should be working. They should be able to rely on a normal, expected functionality.

For the note: Karol told me he would take a look into the memory issue because he know that this is a driver issue


In the meantime i had the issue that suddenly the picture start flickering. It then flicker whole time. The OS was unusable. The computer had to be restarted to stop this flickering.
I looked around in the internet and this seems to be also a driver issue. 
This issue is also now the second time there. It appear when i start scrolling up and down the https://bugzilla.freedesktop.org website with the Mozilla Firefox browser. Should i open a second bugreport for this issue or is it related? I cant find anything in dmesg or any other logfiles. The os is flickering when opening windows, scrolling in the webbrowser, or any other movement.
Comment 8 Jordan Belfort 2019-04-24 10:45:03 UTC
The mistake messages originate from _glamor_create_tex() which is called by glamor_create_fbo(), and when this happens, pixmap_priv->fbo is set to NULL since, well, the FBO couldn't be distributed. http://www.domyassignmentforme.com/help-homework
Comment 9 Karol Herbst 2019-05-04 17:14:38 UTC
(In reply to wixbisce@guerrillamail.com from comment #7)
> I talked with a developer. I get told, that when a driver provide a
> functionality, that functionality should be working. They should be able to
> rely on a normal, expected functionality.
> 

I don't see how that is a Nouveau issue except somebody shows otherwise. Sure Nouveau should be able to handle out of memory situations better, but the issue here is, that glamor crashes. This is nothing Nouveau could prevent.

Anyway, ignoring that out of memory issue for now. It's not even proven that the crash actually resulted from this out of memory error (even though it is likely). Glamor tries to workaround it, but fails.
Comment 10 Karol Herbst 2019-05-04 17:17:50 UTC
anyway, there seem to be some glamor bugs filed against this already:
https://gitlab.freedesktop.org/xorg/xserver/issues?scope=all&utf8=%E2%9C%93&state=opened&search=OsLookupColor
Comment 11 Karol Herbst 2019-05-04 17:20:00 UTC
If you don't think any of the glamor bugs fit, feel free to open a bug against glamor on gitlab.
Comment 12 Karol Herbst 2019-05-04 17:41:19 UTC
also testing with a more updated stack might help as 18.04 still only uses X 1.19 and this issue might have been fixed already...
Comment 13 Karol Herbst 2019-05-04 17:51:19 UTC
actually. this was tracked in this bug and is already fixed: https://gitlab.freedesktop.org/xorg/xserver/issues/647
Comment 14 wixbisce@guerrillamail.com 2019-05-10 21:51:36 UTC
Thanks for the information. Now i try to understand what software version i have to use to be able to use this fix so that the system stops crashing.
Comment 15 Juddy Piterson 2019-08-07 20:20:16 UTC
If you jot a note down on paper, save it and use the rest of the sheet for your notes. American business waste 21 million tonnes of paper per annum! Ideally, try to have your business as paperless as possible https://essaywritingstore.com/writing-movie-critique . When it is absolutely necessary, print on both sides of the page. And don’t forget to recycle it!


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.